##### Activity
# Predators and Prey
Inquiry Activity

### Learning Objectives
- [LO 2.3.1] Use models and simulations to represent phenomena. [P3]
- [LO 2.3.2] Use models and simulations to formulate, refine, and test hypotheses. [P3]

## Predators and Prey

In this activity the students will use a simulation of the relationship between predators and prey to formulate, test, and refine hypotheses. 

Explain to the students that computers can be used to model real life situations, such as the interaction between predators and prey in the wild.

Instruct the students to open the CodeCombat level "Peasants and Munchkins":
https://codecombat.com/play/level/peasants-and-munchkins

In this simulation, we've modeled the predators as Ogres and the prey as Peasants. The prey search for food (coins) while the predators search for the prey.

**The students can control several variables that affect how the simulation plays out:**

- Number of ogres and peasants at the start of the simulation.
- Ogre and peasant movement speed.
- Number of peasants an ogre needs to catch to spawn a new ogre.
- Number of coins a peasant needs to collect to spawn a new peasant.
- How far an ogre can see a peasant, or a peasant can see a coin.
- Number of seconds an ogre survives without catching a peasant.
- Number of seconds a peasant survives without collecting a coin.
- Number of seconds between coin spawns.
- Number of coins in each coin spawn.

### Activity:

Explain to the students:

> The goal of the simulation is to change the variables in order to create a stable ecosystem where both the predators and prey survive in harmony. Both species depend on each other for survival - so if one disappears, the other usually does, too! 

Each student should begin by running the simulation with the default settings. It fails! Then, have each student go through the following steps:

1. Have each student write down a Hypothesis, explaining how they will change one of the simulation variables, and make a prediction about how this change will affect the outcome.
2. Have the students run the simulation with the new, changed, variable.
3. Write down what the actual outcome was, and compare with the predicted outcome.
4. Go back to step 1, and repeat.

The students should repeat these steps multiple times, each time recording a new hypothesis and new result, building on the previous result.


### Discussion Questions:
- Why are simulations useful for testing real life situations?
- How do simulations use abstractions?
- How does this level accurately model real life predator/prey behavior?
- What are some weaknesses of this model? How could it be improved?
- Does this model have too many, or too few, variables?
- What other real world situations could the students use computers to model and simulate?

### Assessment Questions:
- What does the Predator and Prey simulation omit when it models real life? [EK 2.3.1A]
- What are the tradeoffs if you were to add these omitted details? [EK 2.3.1C]
- How did your hypotheses change as you experimented with the model? [EK 2.3.2C]
- What are the benefits of modeling situations like these on computers? [EK 2.3.2E]
- What are some examples of models being used in society? [EU 2.3]
